diff --git a/gcc/asan.c b/gcc/asan.c
index b8acaf7..b76acf4 100644
--- a/gcc/asan.c
+++ b/gcc/asan.c
@@ -2248,26 +2248,35 @@ gate_asan (void)
 				DECL_ATTRIBUTES (current_function_decl));
 }
 
-struct gimple_opt_pass pass_asan =
+class pass_asan : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "asan",				/* name  */
-  OPTGROUP_NONE,			/* optinfo_flags */
-  gate_asan,				/* gate  */
-  asan_instrument,			/* execute  */
-  NULL,					/* sub  */
-  NULL,					/* next  */
-  0,					/* static_pass_number  */
-  TV_NONE,				/* tv_id  */
-  PROP_ssa | PROP_cfg | PROP_gimple_leh,/* properties_required  */
-  0,					/* properties_provided  */
-  0,					/* properties_destroyed  */
-  0,					/* todo_flags_start  */
-  TODO_verify_flow | TODO_verify_stmts
-  | TODO_update_ssa			/* todo_flags_finish  */
- }
-};
+public:
+  pass_asan(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "asan",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa | PROP_cfg | PROP_gimple_leh),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_flow | TODO_verify_stmts | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_asan (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return asan_instrument (); }
+
+}; // class pass_asan
+
+gimple_opt_pass *
+make_pass_asan (context &ctxt)
+{
+  return new pass_asan (ctxt);
+}
 
 static bool
 gate_asan_O0 (void)
@@ -2275,25 +2284,34 @@ gate_asan_O0 (void)
   return !optimize && gate_asan ();
 }
 
-struct gimple_opt_pass pass_asan_O0 =
+class pass_asan_O0 : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "asan0",				/* name  */
-  OPTGROUP_NONE,			/* optinfo_flags */
-  gate_asan_O0,				/* gate  */
-  asan_instrument,			/* execute  */
-  NULL,					/* sub  */
-  NULL,					/* next  */
-  0,					/* static_pass_number  */
-  TV_NONE,				/* tv_id  */
-  PROP_ssa | PROP_cfg | PROP_gimple_leh,/* properties_required  */
-  0,					/* properties_provided  */
-  0,					/* properties_destroyed  */
-  0,					/* todo_flags_start  */
-  TODO_verify_flow | TODO_verify_stmts
-  | TODO_update_ssa			/* todo_flags_finish  */
- }
-};
+public:
+  pass_asan_O0(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "asan0",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa | PROP_cfg | PROP_gimple_leh),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_flow | TODO_verify_stmts | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_asan_O0 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return asan_instrument (); }
+
+}; // class pass_asan_O0
+
+gimple_opt_pass *
+make_pass_asan_O0 (context &ctxt)
+{
+  return new pass_asan_O0 (ctxt);
+}
 
 #include "gt-asan.h"
diff --git a/gcc/auto-inc-dec.c b/gcc/auto-inc-dec.c
index 6119bb6..f942f49 100644
--- a/gcc/auto-inc-dec.c
+++ b/gcc/auto-inc-dec.c
@@ -1506,22 +1506,32 @@ gate_auto_inc_dec (void)
 }
 
 
-struct rtl_opt_pass pass_inc_dec =
+class pass_inc_dec : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "auto_inc_dec",                       /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_auto_inc_dec,                    /* gate */
-  rest_of_handle_auto_inc_dec,          /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_AUTO_INC_DEC,                      /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish,                       /* todo_flags_finish */
- }
-};
+public:
+  pass_inc_dec(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "auto_inc_dec",
+		   OPTGROUP_NONE,
+		   TV_AUTO_INC_DEC,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_auto_inc_dec (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_auto_inc_dec (); }
+
+}; // class pass_inc_dec
+
+rtl_opt_pass *
+make_pass_inc_dec (context &ctxt)
+{
+  return new pass_inc_dec (ctxt);
+}
diff --git a/gcc/bb-reorder.c b/gcc/bb-reorder.c
index abb2e39..16cd3f6 100644
--- a/gcc/bb-reorder.c
+++ b/gcc/bb-reorder.c
@@ -2221,25 +2221,35 @@ rest_of_handle_reorder_blocks (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_reorder_blocks =
+class pass_reorder_blocks : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "bbro",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_reorder_blocks,           /* gate */
-  rest_of_handle_reorder_blocks,        /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_REORDER_BLOCKS,                    /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing,              /* todo_flags_finish */
- }
-};
+public:
+  pass_reorder_blocks(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "bbro",
+		   OPTGROUP_NONE,
+		   TV_REORDER_BLOCKS,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_reorder_blocks (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_reorder_blocks (); }
+
+}; // class pass_reorder_blocks
+
+rtl_opt_pass *
+make_pass_reorder_blocks (context &ctxt)
+{
+  return new pass_reorder_blocks (ctxt);
+}
 
 /* Duplicate the blocks containing computed gotos.  This basically unfactors
    computed gotos that were factored early on in the compilation process to
@@ -2364,25 +2374,35 @@ done:
   return 0;
 }
 
-struct rtl_opt_pass pass_duplicate_computed_gotos =
+class pass_duplicate_computed_gotos : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "compgotos",                          /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_duplicate_computed_gotos,        /* gate */
-  duplicate_computed_gotos,             /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_REORDER_BLOCKS,                    /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing,/* todo_flags_finish */
- }
-};
+public:
+  pass_duplicate_computed_gotos(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "compgotos",
+		   OPTGROUP_NONE,
+		   TV_REORDER_BLOCKS,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_duplicate_computed_gotos (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return duplicate_computed_gotos (); }
+
+}; // class pass_duplicate_computed_gotos
+
+rtl_opt_pass *
+make_pass_duplicate_computed_gotos (context &ctxt)
+{
+  return new pass_duplicate_computed_gotos (ctxt);
+}
 
 static bool
 gate_handle_partition_blocks (void)
@@ -2568,22 +2588,34 @@ partition_hot_cold_basic_blocks (void)
   return TODO_verify_flow | TODO_verify_rtl_sharing;
 }
 
-struct rtl_opt_pass pass_partition_blocks =
+class pass_partition_blocks : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "bbpart",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_partition_blocks,         /* gate */
-  partition_hot_cold_basic_blocks,      /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_REORDER_BLOCKS,                    /* tv_id */
-  PROP_cfglayout,                       /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_partition_blocks(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "bbpart",
+		   OPTGROUP_NONE,
+		   TV_REORDER_BLOCKS,
+		   pass_properties(required(PROP_cfglayout),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_partition_blocks (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return partition_hot_cold_basic_blocks ();
+  }
+
+}; // class pass_partition_blocks
+
+rtl_opt_pass *
+make_pass_partition_blocks (context &ctxt)
+{
+  return new pass_partition_blocks (ctxt);
+}
diff --git a/gcc/bt-load.c b/gcc/bt-load.c
index 9ca1bd9..f02344c 100644
--- a/gcc/bt-load.c
+++ b/gcc/bt-load.c
@@ -1504,25 +1504,37 @@ rest_of_handle_branch_target_load_optimize1 (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_branch_target_load_optimize1 =
+class pass_branch_target_load_optimize1 : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "btl1",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_branch_target_load_optimize1,      /* gate */
-  rest_of_handle_branch_target_load_optimize1,   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,	                        /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing,              /* todo_flags_finish */
- }
-};
+public:
+  pass_branch_target_load_optimize1(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "btl1",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_branch_target_load_optimize1 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_branch_target_load_optimize1 ();
+  }
+
+}; // class pass_branch_target_load_optimize1
+
+rtl_opt_pass *
+make_pass_branch_target_load_optimize1 (context &ctxt)
+{
+  return new pass_branch_target_load_optimize1 (ctxt);
+}
 
 static bool
 gate_handle_branch_target_load_optimize2 (void)
@@ -1553,22 +1565,34 @@ rest_of_handle_branch_target_load_optimize2 (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_branch_target_load_optimize2 =
+class pass_branch_target_load_optimize2 : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "btl2",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_branch_target_load_optimize2,      /* gate */
-  rest_of_handle_branch_target_load_optimize2,   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0,                                    /* todo_flags_finish */
- }
-};
+public:
+  pass_branch_target_load_optimize2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "btl2",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_branch_target_load_optimize2 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_branch_target_load_optimize2 ();
+  }
+
+}; // class pass_branch_target_load_optimize2
+
+rtl_opt_pass *
+make_pass_branch_target_load_optimize2 (context &ctxt)
+{
+  return new pass_branch_target_load_optimize2 (ctxt);
+}
diff --git a/gcc/cfgcleanup.c b/gcc/cfgcleanup.c
index 7764c6c..2a32963 100644
--- a/gcc/cfgcleanup.c
+++ b/gcc/cfgcleanup.c
@@ -3040,25 +3040,35 @@ execute_jump (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_jump =
+class pass_jump : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "jump",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_jump,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_JUMP,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_rtl_sharing,		/* todo_flags_finish */
- }
-};
+public:
+  pass_jump(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "jump",
+		   OPTGROUP_NONE,
+		   TV_JUMP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_jump (); }
+
+}; // class pass_jump
+
+rtl_opt_pass *
+make_pass_jump (context &ctxt)
+{
+  return new pass_jump (ctxt);
+}
 
 static unsigned int
 execute_jump2 (void)
@@ -3067,22 +3077,32 @@ execute_jump2 (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_jump2 =
+class pass_jump2 : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "jump2",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_jump2,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_JUMP,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_rtl_sharing,		/* todo_flags_finish */
- }
-};
+public:
+  pass_jump2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "jump2",
+		   OPTGROUP_NONE,
+		   TV_JUMP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_jump2 (); }
+
+}; // class pass_jump2
+
+rtl_opt_pass *
+make_pass_jump2 (context &ctxt)
+{
+  return new pass_jump2 (ctxt);
+}
diff --git a/gcc/cfgexpand.c b/gcc/cfgexpand.c
index a651d8c..6d162d6 100644
--- a/gcc/cfgexpand.c
+++ b/gcc/cfgexpand.c
@@ -4845,25 +4845,32 @@ gimple_expand_cfg (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_expand =
+class pass_expand : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "expand",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  gimple_expand_cfg,			/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_EXPAND,				/* tv_id */
-  PROP_ssa | PROP_gimple_leh | PROP_cfg
-    | PROP_gimple_lcx
-    | PROP_gimple_lvec,			/* properties_required */
-  PROP_rtl,                             /* properties_provided */
-  PROP_ssa | PROP_trees,		/* properties_destroyed */
-  TODO_verify_ssa | TODO_verify_flow
-    | TODO_verify_stmts,		/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_expand(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "expand",
+		   OPTGROUP_NONE,
+		   TV_EXPAND,
+		   pass_properties(required(PROP_ssa | PROP_gimple_leh | PROP_cfg | PROP_gimple_lcx | PROP_gimple_lvec),
+				   provided(PROP_rtl),
+				   destroyed(PROP_ssa | PROP_trees)),
+		   pass_todo_flags(start(TODO_verify_ssa | TODO_verify_flow | TODO_verify_stmts),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return gimple_expand_cfg (); }
+
+}; // class pass_expand
+
+rtl_opt_pass *
+make_pass_expand (context &ctxt)
+{
+  return new pass_expand (ctxt);
+}
diff --git a/gcc/cfgrtl.c b/gcc/cfgrtl.c
index 9b12d28..6160a27 100644
--- a/gcc/cfgrtl.c
+++ b/gcc/cfgrtl.c
@@ -455,25 +455,35 @@ rest_of_pass_free_cfg (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_free_cfg =
+class pass_free_cfg : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "*free_cfg",                          /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_pass_free_cfg,                /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  PROP_cfg,                             /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0,                                    /* todo_flags_finish */
- }
-};
+public:
+  pass_free_cfg(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "*free_cfg",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(PROP_cfg)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_pass_free_cfg (); }
+
+}; // class pass_free_cfg
+
+rtl_opt_pass *
+make_pass_free_cfg (context &ctxt)
+{
+  return new pass_free_cfg (ctxt);
+}
 
 /* Return RTX to emit after when we want to emit code on the entry of function.  */
 rtx
@@ -3036,45 +3046,65 @@ outof_cfg_layout_mode (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_into_cfg_layout_mode =
+class pass_into_cfg_layout_mode : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "into_cfglayout",                     /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  into_cfg_layout_mode,                 /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_CFG,                               /* tv_id */
-  0,                                    /* properties_required */
-  PROP_cfglayout,                       /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_into_cfg_layout_mode(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "into_cfglayout",
+		   OPTGROUP_NONE,
+		   TV_CFG,
+		   pass_properties(required(0),
+				   provided(PROP_cfglayout),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return into_cfg_layout_mode (); }
+
+}; // class pass_into_cfg_layout_mode
+
+rtl_opt_pass *
+make_pass_into_cfg_layout_mode (context &ctxt)
+{
+  return new pass_into_cfg_layout_mode (ctxt);
+}
 
-struct rtl_opt_pass pass_outof_cfg_layout_mode =
+class pass_outof_cfg_layout_mode : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "outof_cfglayout",                    /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  outof_cfg_layout_mode,                /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_CFG,                               /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  PROP_cfglayout,                       /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_outof_cfg_layout_mode(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "outof_cfglayout",
+		   OPTGROUP_NONE,
+		   TV_CFG,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(PROP_cfglayout)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return outof_cfg_layout_mode (); }
+
+}; // class pass_outof_cfg_layout_mode
+
+rtl_opt_pass *
+make_pass_outof_cfg_layout_mode (context &ctxt)
+{
+  return new pass_outof_cfg_layout_mode (ctxt);
+}
 
 
 /* Link the basic blocks in the correct order, compacting the basic
diff --git a/gcc/cgraphbuild.c b/gcc/cgraphbuild.c
index a74a4c0..da3c6b1 100644
--- a/gcc/cgraphbuild.c
+++ b/gcc/cgraphbuild.c
@@ -364,25 +364,35 @@ build_cgraph_edges (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_build_cgraph_edges =
+class pass_build_cgraph_edges : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "*build_cgraph_edges",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  build_cgraph_edges,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_build_cgraph_edges(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*build_cgraph_edges",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return build_cgraph_edges (); }
+
+}; // class pass_build_cgraph_edges
+
+gimple_opt_pass *
+make_pass_build_cgraph_edges (context &ctxt)
+{
+  return new pass_build_cgraph_edges (ctxt);
+}
 
 /* Record references to functions and other variables present in the
    initial value of DECL, a variable.
@@ -482,25 +492,35 @@ cgraph_rebuild_references (void)
   record_eh_tables (node, cfun);
 }
 
-struct gimple_opt_pass pass_rebuild_cgraph_edges =
+class pass_rebuild_cgraph_edges : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "*rebuild_cgraph_edges",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  rebuild_cgraph_edges,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_CGRAPH,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0,					/* todo_flags_finish */
- }
-};
+public:
+  pass_rebuild_cgraph_edges(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*rebuild_cgraph_edges",
+		      OPTGROUP_NONE,
+		      TV_CGRAPH,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rebuild_cgraph_edges (); }
+
+}; // class pass_rebuild_cgraph_edges
+
+gimple_opt_pass *
+make_pass_rebuild_cgraph_edges (context &ctxt)
+{
+  return new pass_rebuild_cgraph_edges (ctxt);
+}
 
 
 static unsigned int
@@ -510,22 +530,32 @@ remove_cgraph_callee_edges (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_remove_cgraph_callee_edges =
+class pass_remove_cgraph_callee_edges : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "*remove_cgraph_callee_edges",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  remove_cgraph_callee_edges,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0,					/* todo_flags_finish */
- }
-};
+public:
+  pass_remove_cgraph_callee_edges(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*remove_cgraph_callee_edges",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return remove_cgraph_callee_edges (); }
+
+}; // class pass_remove_cgraph_callee_edges
+
+gimple_opt_pass *
+make_pass_remove_cgraph_callee_edges (context &ctxt)
+{
+  return new pass_remove_cgraph_callee_edges (ctxt);
+}
diff --git a/gcc/combine-stack-adj.c b/gcc/combine-stack-adj.c
index 7392b92..88fdd1a 100644
--- a/gcc/combine-stack-adj.c
+++ b/gcc/combine-stack-adj.c
@@ -643,22 +643,34 @@ rest_of_handle_stack_adjustments (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_stack_adjustments =
+class pass_stack_adjustments : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "csa",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_stack_adjustments,        /* gate */
-  rest_of_handle_stack_adjustments,     /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_COMBINE_STACK_ADJUST,              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+public:
+  pass_stack_adjustments(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "csa",
+		   OPTGROUP_NONE,
+		   TV_COMBINE_STACK_ADJUST,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_stack_adjustments (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_stack_adjustments ();
+  }
+
+}; // class pass_stack_adjustments
+
+rtl_opt_pass *
+make_pass_stack_adjustments (context &ctxt)
+{
+  return new pass_stack_adjustments (ctxt);
+}
diff --git a/gcc/combine.c b/gcc/combine.c
index 6d58b19..21c0fef 100644
--- a/gcc/combine.c
+++ b/gcc/combine.c
@@ -13802,22 +13802,32 @@ rest_of_handle_combine (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_combine =
+class pass_combine : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "combine",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_combine,                  /* gate */
-  rest_of_handle_combine,               /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_COMBINE,                           /* tv_id */
-  PROP_cfglayout,                       /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+public:
+  pass_combine(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "combine",
+		   OPTGROUP_NONE,
+		   TV_COMBINE,
+		   pass_properties(required(PROP_cfglayout),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_combine (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_combine (); }
+
+}; // class pass_combine
+
+rtl_opt_pass *
+make_pass_combine (context &ctxt)
+{
+  return new pass_combine (ctxt);
+}
